pub type AllocTab = &'static [i8; 16];

pub const HALF_BITRATE_IDX: [i8; 15] = [ 0, 1, 1, 1, 1, 2, 2, 3, 4, 5, 6, 7, 8, 9, 10 ];

pub const LAYER2_BITS: [[&[u8; 32]; 16]; 3] = [
  [ // 44.1kHz
    BITS_B2B, BITS_B2C, BITS_B2C, BITS_B2A, BITS_B2A, BITS_B2A,
    BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B,
    BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B
  ], [ // 48kHz
    BITS_B2A, BITS_B2C, BITS_B2C, BITS_B2A, BITS_B2A, BITS_B2A,
    BITS_B2A, BITS_B2A, BITS_B2A, BITS_B2A, BITS_B2A,
    BITS_B2A, BITS_B2A, BITS_B2A, BITS_B2A, BITS_B2A
  ], [ // 32kHz
    BITS_B2B, BITS_B2D, BITS_B2D, BITS_B2A, BITS_B2A, BITS_B2A,
    BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B,
    BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B, BITS_B2B
  ]
];
pub const LAYER2_ALLOC: [&[AllocTab; 32]; 16] = [
    ALLOC_B2AB, ALLOC_B2CD, ALLOC_B2CD, ALLOC_B2AB,
    ALLOC_B2AB, ALLOC_B2AB, ALLOC_B2AB, ALLOC_B2AB,
    ALLOC_B2AB, ALLOC_B2AB, ALLOC_B2AB, ALLOC_B2AB,
    ALLOC_B2AB, ALLOC_B2AB, ALLOC_B2AB, ALLOC_B2AB
];

const BITS_B2A: &[u8; 32] = &[
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3,
    3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 0, 0, 0, 0, 0
];
const BITS_B2B: &[u8; 32] = &[
    4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 3, 3, 3, 3, 3,
    3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 0, 0
];
const BITS_B2C: &[u8; 32] = &[
    4, 4, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
];
const BITS_B2D: &[u8; 32] = &[
    4, 4, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 0, 0, 0, 0,
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
];

const QCLASS0: AllocTab = &[
    0, -5,  3,   4,   5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15, 16
];
const QCLASS1: AllocTab = &[
    0, -5, -7,   3, -10,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 16
];
const QCLASS2: AllocTab = &[
    0, -5, -7,   3, -10,  4,  5, 16,  0,  0,  0,  0,  0,  0,  0,  0
];
const QCLASS3: AllocTab = &[
    0, -5, -7,  16,   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
];
const QCLASS4: AllocTab = &[
    0, -5, -7, -10,   4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
];
const QCLASS5: AllocTab = &[
    0, -5, -7, -10,   4,  5,  6,  7,  0,  0,  0,  0,  0,  0,  0,  0
];
const QCLASS6: AllocTab = &[
    0, -5, -7,   3, -10,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14
];
const QCLASS7: AllocTab = &[
    0, -5, -7, -10,   0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0
];
const QCLASS_NONE: AllocTab = &[ 0; 16];

const ALLOC_B2AB: &[AllocTab; 32] = &[
    QCLASS0, QCLASS0, QCLASS0, QCLASS1, QCLASS1, QCLASS1, QCLASS1, QCLASS1,
    QCLASS1, QCLASS1, QCLASS1, QCLASS2, QCLASS2, QCLASS2, QCLASS2, QCLASS2,
    QCLASS2, QCLASS2, QCLASS2, QCLASS2, QCLASS2, QCLASS2, QCLASS2, QCLASS3,
    QCLASS3, QCLASS3, QCLASS3, QCLASS3, QCLASS3, QCLASS3,
    QCLASS_NONE, QCLASS_NONE
];
const ALLOC_B2CD: &[AllocTab; 32] = &[
    QCLASS4, QCLASS4, QCLASS5, QCLASS5, QCLASS5, QCLASS5, QCLASS5, QCLASS5,
    QCLASS5, QCLASS5, QCLASS5, QCLASS5,
    QCLASS_NONE, QCLASS_NONE, QCLASS_NONE, QCLASS_NONE,
    QCLASS_NONE, QCLASS_NONE, QCLASS_NONE, QCLASS_NONE,
    QCLASS_NONE, QCLASS_NONE, QCLASS_NONE, QCLASS_NONE,
    QCLASS_NONE, QCLASS_NONE, QCLASS_NONE, QCLASS_NONE,
    QCLASS_NONE, QCLASS_NONE, QCLASS_NONE, QCLASS_NONE
];

pub const BITS_B2LFE: &[u8; 32] = &[
    4, 4, 4, 4, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2,
    2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 0, 0
];
pub const ALLOC_B2LFE: &[AllocTab; 32] = &[
    QCLASS6, QCLASS6, QCLASS6, QCLASS6, QCLASS5, QCLASS5, QCLASS5, QCLASS5,
    QCLASS5, QCLASS5, QCLASS5, QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7,
    QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7,
    QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7, QCLASS7,
    QCLASS_NONE, QCLASS_NONE
];

pub const QUANTS: [f32; 64] = [
    2.00000000000000, 1.58740105196820, 1.25992104989487, 1.00000000000000,
    0.79370052598410, 0.62996052494744, 0.50000000000000, 0.39685026299205,
    0.31498026247372, 0.25000000000000, 0.19842513149602, 0.15749013123686,
    0.12500000000000, 0.09921256574801, 0.07874506561843, 0.06250000000000,
    0.04960628287401, 0.03937253280921, 0.03125000000000, 0.02480314143700,
    0.01968626640461, 0.01562500000000, 0.01240157071850, 0.00984313320230,
    0.00781250000000, 0.00620078535925, 0.00492156660115, 0.00390625000000,
    0.00310039267963, 0.00246078330058, 0.00195312500000, 0.00155019633981,
    0.00123039165029, 0.00097656250000, 0.00077509816991, 0.00061519582514,
    0.00048828125000, 0.00038754908495, 0.00030759791257, 0.00024414062500,
    0.00019377454248, 0.00015379895629, 0.00012207031250, 0.00009688727124,
    0.00007689947814, 0.00006103515625, 0.00004844363562, 0.00003844973907,
    0.00003051757813, 0.00002422181781, 0.00001922486954, 0.00001525878906,
    0.00001211090890, 0.00000961243477, 0.00000762939453, 0.00000605545445,
    0.00000480621738, 0.00000381469727, 0.00000302772723, 0.00000240310869,
    0.00000190734863, 0.00000151386361, 0.00000120155435, 0.0
];

pub const GROUP3: [[u8; 3]; 32] = [
    [0, 0, 0], [1, 0, 0], [2, 0, 0],
    [0, 1, 0], [1, 1, 0], [2, 1, 0],
    [0, 2, 0], [1, 2, 0], [2, 2, 0],
    [0, 0, 1], [1, 0, 1], [2, 0, 1],
    [0, 1, 1], [1, 1, 1], [2, 1, 1],
    [0, 2, 1], [1, 2, 1], [2, 2, 1],
    [0, 0, 2], [1, 0, 2], [2, 0, 2],
    [0, 1, 2], [1, 1, 2], [2, 1, 2],
    [0, 2, 2], [1, 2, 2], [2, 2, 2],

    [0, 0, 3], [1, 0, 3], [2, 0, 3],
    [0, 1, 3], [1, 1, 3]
];

pub const GROUP5: [[u8; 3]; 128] = [
    [0, 0, 0], [1, 0, 0], [2, 0, 0], [3, 0, 0], [4, 0, 0],
    [0, 1, 0], [1, 1, 0], [2, 1, 0], [3, 1, 0], [4, 1, 0],
    [0, 2, 0], [1, 2, 0], [2, 2, 0], [3, 2, 0], [4, 2, 0],
    [0, 3, 0], [1, 3, 0], [2, 3, 0], [3, 3, 0], [4, 3, 0],
    [0, 4, 0], [1, 4, 0], [2, 4, 0], [3, 4, 0], [4, 4, 0],
    [0, 0, 1], [1, 0, 1], [2, 0, 1], [3, 0, 1], [4, 0, 1],
    [0, 1, 1], [1, 1, 1], [2, 1, 1], [3, 1, 1], [4, 1, 1],
    [0, 2, 1], [1, 2, 1], [2, 2, 1], [3, 2, 1], [4, 2, 1],
    [0, 3, 1], [1, 3, 1], [2, 3, 1], [3, 3, 1], [4, 3, 1],
    [0, 4, 1], [1, 4, 1], [2, 4, 1], [3, 4, 1], [4, 4, 1],
    [0, 0, 2], [1, 0, 2], [2, 0, 2], [3, 0, 2], [4, 0, 2],
    [0, 1, 2], [1, 1, 2], [2, 1, 2], [3, 1, 2], [4, 1, 2],
    [0, 2, 2], [1, 2, 2], [2, 2, 2], [3, 2, 2], [4, 2, 2],
    [0, 3, 2], [1, 3, 2], [2, 3, 2], [3, 3, 2], [4, 3, 2],
    [0, 4, 2], [1, 4, 2], [2, 4, 2], [3, 4, 2], [4, 4, 2],
    [0, 0, 3], [1, 0, 3], [2, 0, 3], [3, 0, 3], [4, 0, 3],
    [0, 1, 3], [1, 1, 3], [2, 1, 3], [3, 1, 3], [4, 1, 3],
    [0, 2, 3], [1, 2, 3], [2, 2, 3], [3, 2, 3], [4, 2, 3],
    [0, 3, 3], [1, 3, 3], [2, 3, 3], [3, 3, 3], [4, 3, 3],
    [0, 4, 3], [1, 4, 3], [2, 4, 3], [3, 4, 3], [4, 4, 3],
    [0, 0, 4], [1, 0, 4], [2, 0, 4], [3, 0, 4], [4, 0, 4],
    [0, 1, 4], [1, 1, 4], [2, 1, 4], [3, 1, 4], [4, 1, 4],
    [0, 2, 4], [1, 2, 4], [2, 2, 4], [3, 2, 4], [4, 2, 4],
    [0, 3, 4], [1, 3, 4], [2, 3, 4], [3, 3, 4], [4, 3, 4],
    [0, 4, 4], [1, 4, 4], [2, 4, 4], [3, 4, 4], [4, 4, 4],

    [0, 0, 5], [1, 0, 5], [2, 0, 5]
];

pub const GROUP9: [[u8; 3]; 1024] = [
    [0, 0, 0], [1, 0, 0], [2, 0, 0], [3, 0, 0], [4, 0, 0], [5, 0, 0], [6, 0, 0], [7, 0, 0], [8, 0, 0],
    [0, 1, 0], [1, 1, 0], [2, 1, 0], [3, 1, 0], [4, 1, 0], [5, 1, 0], [6, 1, 0], [7, 1, 0], [8, 1, 0],
    [0, 2, 0], [1, 2, 0], [2, 2, 0], [3, 2, 0], [4, 2, 0], [5, 2, 0], [6, 2, 0], [7, 2, 0], [8, 2, 0],
    [0, 3, 0], [1, 3, 0], [2, 3, 0], [3, 3, 0], [4, 3, 0], [5, 3, 0], [6, 3, 0], [7, 3, 0], [8, 3, 0],
    [0, 4, 0], [1, 4, 0], [2, 4, 0], [3, 4, 0], [4, 4, 0], [5, 4, 0], [6, 4, 0], [7, 4, 0], [8, 4, 0],
    [0, 5, 0], [1, 5, 0], [2, 5, 0], [3, 5, 0], [4, 5, 0], [5, 5, 0], [6, 5, 0], [7, 5, 0], [8, 5, 0],
    [0, 6, 0], [1, 6, 0], [2, 6, 0], [3, 6, 0], [4, 6, 0], [5, 6, 0], [6, 6, 0], [7, 6, 0], [8, 6, 0],
    [0, 7, 0], [1, 7, 0], [2, 7, 0], [3, 7, 0], [4, 7, 0], [5, 7, 0], [6, 7, 0], [7, 7, 0], [8, 7, 0],
    [0, 8, 0], [1, 8, 0], [2, 8, 0], [3, 8, 0], [4, 8, 0], [5, 8, 0], [6, 8, 0], [7, 8, 0], [8, 8, 0],
    [0, 0, 1], [1, 0, 1], [2, 0, 1], [3, 0, 1], [4, 0, 1], [5, 0, 1], [6, 0, 1], [7, 0, 1], [8, 0, 1],
    [0, 1, 1], [1, 1, 1], [2, 1, 1], [3, 1, 1], [4, 1, 1], [5, 1, 1], [6, 1, 1], [7, 1, 1], [8, 1, 1],
    [0, 2, 1], [1, 2, 1], [2, 2, 1], [3, 2, 1], [4, 2, 1], [5, 2, 1], [6, 2, 1], [7, 2, 1], [8, 2, 1],
    [0, 3, 1], [1, 3, 1], [2, 3, 1], [3, 3, 1], [4, 3, 1], [5, 3, 1], [6, 3, 1], [7, 3, 1], [8, 3, 1],
    [0, 4, 1], [1, 4, 1], [2, 4, 1], [3, 4, 1], [4, 4, 1], [5, 4, 1], [6, 4, 1], [7, 4, 1], [8, 4, 1],
    [0, 5, 1], [1, 5, 1], [2, 5, 1], [3, 5, 1], [4, 5, 1], [5, 5, 1], [6, 5, 1], [7, 5, 1], [8, 5, 1],
    [0, 6, 1], [1, 6, 1], [2, 6, 1], [3, 6, 1], [4, 6, 1], [5, 6, 1], [6, 6, 1], [7, 6, 1], [8, 6, 1],
    [0, 7, 1], [1, 7, 1], [2, 7, 1], [3, 7, 1], [4, 7, 1], [5, 7, 1], [6, 7, 1], [7, 7, 1], [8, 7, 1],
    [0, 8, 1], [1, 8, 1], [2, 8, 1], [3, 8, 1], [4, 8, 1], [5, 8, 1], [6, 8, 1], [7, 8, 1], [8, 8, 1],
    [0, 0, 2], [1, 0, 2], [2, 0, 2], [3, 0, 2], [4, 0, 2], [5, 0, 2], [6, 0, 2], [7, 0, 2], [8, 0, 2],
    [0, 1, 2], [1, 1, 2], [2, 1, 2], [3, 1, 2], [4, 1, 2], [5, 1, 2], [6, 1, 2], [7, 1, 2], [8, 1, 2],
    [0, 2, 2], [1, 2, 2], [2, 2, 2], [3, 2, 2], [4, 2, 2], [5, 2, 2], [6, 2, 2], [7, 2, 2], [8, 2, 2],
    [0, 3, 2], [1, 3, 2], [2, 3, 2], [3, 3, 2], [4, 3, 2], [5, 3, 2], [6, 3, 2], [7, 3, 2], [8, 3, 2],
    [0, 4, 2], [1, 4, 2], [2, 4, 2], [3, 4, 2], [4, 4, 2], [5, 4, 2], [6, 4, 2], [7, 4, 2], [8, 4, 2],
    [0, 5, 2], [1, 5, 2], [2, 5, 2], [3, 5, 2], [4, 5, 2], [5, 5, 2], [6, 5, 2], [7, 5, 2], [8, 5, 2],
    [0, 6, 2], [1, 6, 2], [2, 6, 2], [3, 6, 2], [4, 6, 2], [5, 6, 2], [6, 6, 2], [7, 6, 2], [8, 6, 2],
    [0, 7, 2], [1, 7, 2], [2, 7, 2], [3, 7, 2], [4, 7, 2], [5, 7, 2], [6, 7, 2], [7, 7, 2], [8, 7, 2],
    [0, 8, 2], [1, 8, 2], [2, 8, 2], [3, 8, 2], [4, 8, 2], [5, 8, 2], [6, 8, 2], [7, 8, 2], [8, 8, 2],
    [0, 0, 3], [1, 0, 3], [2, 0, 3], [3, 0, 3], [4, 0, 3], [5, 0, 3], [6, 0, 3], [7, 0, 3], [8, 0, 3],
    [0, 1, 3], [1, 1, 3], [2, 1, 3], [3, 1, 3], [4, 1, 3], [5, 1, 3], [6, 1, 3], [7, 1, 3], [8, 1, 3],
    [0, 2, 3], [1, 2, 3], [2, 2, 3], [3, 2, 3], [4, 2, 3], [5, 2, 3], [6, 2, 3], [7, 2, 3], [8, 2, 3],
    [0, 3, 3], [1, 3, 3], [2, 3, 3], [3, 3, 3], [4, 3, 3], [5, 3, 3], [6, 3, 3], [7, 3, 3], [8, 3, 3],
    [0, 4, 3], [1, 4, 3], [2, 4, 3], [3, 4, 3], [4, 4, 3], [5, 4, 3], [6, 4, 3], [7, 4, 3], [8, 4, 3],
    [0, 5, 3], [1, 5, 3], [2, 5, 3], [3, 5, 3], [4, 5, 3], [5, 5, 3], [6, 5, 3], [7, 5, 3], [8, 5, 3],
    [0, 6, 3], [1, 6, 3], [2, 6, 3], [3, 6, 3], [4, 6, 3], [5, 6, 3], [6, 6, 3], [7, 6, 3], [8, 6, 3],
    [0, 7, 3], [1, 7, 3], [2, 7, 3], [3, 7, 3], [4, 7, 3], [5, 7, 3], [6, 7, 3], [7, 7, 3], [8, 7, 3],
    [0, 8, 3], [1, 8, 3], [2, 8, 3], [3, 8, 3], [4, 8, 3], [5, 8, 3], [6, 8, 3], [7, 8, 3], [8, 8, 3],
    [0, 0, 4], [1, 0, 4], [2, 0, 4], [3, 0, 4], [4, 0, 4], [5, 0, 4], [6, 0, 4], [7, 0, 4], [8, 0, 4],
    [0, 1, 4], [1, 1, 4], [2, 1, 4], [3, 1, 4], [4, 1, 4], [5, 1, 4], [6, 1, 4], [7, 1, 4], [8, 1, 4],
    [0, 2, 4], [1, 2, 4], [2, 2, 4], [3, 2, 4], [4, 2, 4], [5, 2, 4], [6, 2, 4], [7, 2, 4], [8, 2, 4],
    [0, 3, 4], [1, 3, 4], [2, 3, 4], [3, 3, 4], [4, 3, 4], [5, 3, 4], [6, 3, 4], [7, 3, 4], [8, 3, 4],
    [0, 4, 4], [1, 4, 4], [2, 4, 4], [3, 4, 4], [4, 4, 4], [5, 4, 4], [6, 4, 4], [7, 4, 4], [8, 4, 4],
    [0, 5, 4], [1, 5, 4], [2, 5, 4], [3, 5, 4], [4, 5, 4], [5, 5, 4], [6, 5, 4], [7, 5, 4], [8, 5, 4],
    [0, 6, 4], [1, 6, 4], [2, 6, 4], [3, 6, 4], [4, 6, 4], [5, 6, 4], [6, 6, 4], [7, 6, 4], [8, 6, 4],
    [0, 7, 4], [1, 7, 4], [2, 7, 4], [3, 7, 4], [4, 7, 4], [5, 7, 4], [6, 7, 4], [7, 7, 4], [8, 7, 4],
    [0, 8, 4], [1, 8, 4], [2, 8, 4], [3, 8, 4], [4, 8, 4], [5, 8, 4], [6, 8, 4], [7, 8, 4], [8, 8, 4],
    [0, 0, 5], [1, 0, 5], [2, 0, 5], [3, 0, 5], [4, 0, 5], [5, 0, 5], [6, 0, 5], [7, 0, 5], [8, 0, 5],
    [0, 1, 5], [1, 1, 5], [2, 1, 5], [3, 1, 5], [4, 1, 5], [5, 1, 5], [6, 1, 5], [7, 1, 5], [8, 1, 5],
    [0, 2, 5], [1, 2, 5], [2, 2, 5], [3, 2, 5], [4, 2, 5], [5, 2, 5], [6, 2, 5], [7, 2, 5], [8, 2, 5],
    [0, 3, 5], [1, 3, 5], [2, 3, 5], [3, 3, 5], [4, 3, 5], [5, 3, 5], [6, 3, 5], [7, 3, 5], [8, 3, 5],
    [0, 4, 5], [1, 4, 5], [2, 4, 5], [3, 4, 5], [4, 4, 5], [5, 4, 5], [6, 4, 5], [7, 4, 5], [8, 4, 5],
    [0, 5, 5], [1, 5, 5], [2, 5, 5], [3, 5, 5], [4, 5, 5], [5, 5, 5], [6, 5, 5], [7, 5, 5], [8, 5, 5],
    [0, 6, 5], [1, 6, 5], [2, 6, 5], [3, 6, 5], [4, 6, 5], [5, 6, 5], [6, 6, 5], [7, 6, 5], [8, 6, 5],
    [0, 7, 5], [1, 7, 5], [2, 7, 5], [3, 7, 5], [4, 7, 5], [5, 7, 5], [6, 7, 5], [7, 7, 5], [8, 7, 5],
    [0, 8, 5], [1, 8, 5], [2, 8, 5], [3, 8, 5], [4, 8, 5], [5, 8, 5], [6, 8, 5], [7, 8, 5], [8, 8, 5],
    [0, 0, 6], [1, 0, 6], [2, 0, 6], [3, 0, 6], [4, 0, 6], [5, 0, 6], [6, 0, 6], [7, 0, 6], [8, 0, 6],
    [0, 1, 6], [1, 1, 6], [2, 1, 6], [3, 1, 6], [4, 1, 6], [5, 1, 6], [6, 1, 6], [7, 1, 6], [8, 1, 6],
    [0, 2, 6], [1, 2, 6], [2, 2, 6], [3, 2, 6], [4, 2, 6], [5, 2, 6], [6, 2, 6], [7, 2, 6], [8, 2, 6],
    [0, 3, 6], [1, 3, 6], [2, 3, 6], [3, 3, 6], [4, 3, 6], [5, 3, 6], [6, 3, 6], [7, 3, 6], [8, 3, 6],
    [0, 4, 6], [1, 4, 6], [2, 4, 6], [3, 4, 6], [4, 4, 6], [5, 4, 6], [6, 4, 6], [7, 4, 6], [8, 4, 6],
    [0, 5, 6], [1, 5, 6], [2, 5, 6], [3, 5, 6], [4, 5, 6], [5, 5, 6], [6, 5, 6], [7, 5, 6], [8, 5, 6],
    [0, 6, 6], [1, 6, 6], [2, 6, 6], [3, 6, 6], [4, 6, 6], [5, 6, 6], [6, 6, 6], [7, 6, 6], [8, 6, 6],
    [0, 7, 6], [1, 7, 6], [2, 7, 6], [3, 7, 6], [4, 7, 6], [5, 7, 6], [6, 7, 6], [7, 7, 6], [8, 7, 6],
    [0, 8, 6], [1, 8, 6], [2, 8, 6], [3, 8, 6], [4, 8, 6], [5, 8, 6], [6, 8, 6], [7, 8, 6], [8, 8, 6],
    [0, 0, 7], [1, 0, 7], [2, 0, 7], [3, 0, 7], [4, 0, 7], [5, 0, 7], [6, 0, 7], [7, 0, 7], [8, 0, 7],
    [0, 1, 7], [1, 1, 7], [2, 1, 7], [3, 1, 7], [4, 1, 7], [5, 1, 7], [6, 1, 7], [7, 1, 7], [8, 1, 7],
    [0, 2, 7], [1, 2, 7], [2, 2, 7], [3, 2, 7], [4, 2, 7], [5, 2, 7], [6, 2, 7], [7, 2, 7], [8, 2, 7],
    [0, 3, 7], [1, 3, 7], [2, 3, 7], [3, 3, 7], [4, 3, 7], [5, 3, 7], [6, 3, 7], [7, 3, 7], [8, 3, 7],
    [0, 4, 7], [1, 4, 7], [2, 4, 7], [3, 4, 7], [4, 4, 7], [5, 4, 7], [6, 4, 7], [7, 4, 7], [8, 4, 7],
    [0, 5, 7], [1, 5, 7], [2, 5, 7], [3, 5, 7], [4, 5, 7], [5, 5, 7], [6, 5, 7], [7, 5, 7], [8, 5, 7],
    [0, 6, 7], [1, 6, 7], [2, 6, 7], [3, 6, 7], [4, 6, 7], [5, 6, 7], [6, 6, 7], [7, 6, 7], [8, 6, 7],
    [0, 7, 7], [1, 7, 7], [2, 7, 7], [3, 7, 7], [4, 7, 7], [5, 7, 7], [6, 7, 7], [7, 7, 7], [8, 7, 7],
    [0, 8, 7], [1, 8, 7], [2, 8, 7], [3, 8, 7], [4, 8, 7], [5, 8, 7], [6, 8, 7], [7, 8, 7], [8, 8, 7],
    [0, 0, 8], [1, 0, 8], [2, 0, 8], [3, 0, 8], [4, 0, 8], [5, 0, 8], [6, 0, 8], [7, 0, 8], [8, 0, 8],
    [0, 1, 8], [1, 1, 8], [2, 1, 8], [3, 1, 8], [4, 1, 8], [5, 1, 8], [6, 1, 8], [7, 1, 8], [8, 1, 8],
    [0, 2, 8], [1, 2, 8], [2, 2, 8], [3, 2, 8], [4, 2, 8], [5, 2, 8], [6, 2, 8], [7, 2, 8], [8, 2, 8],
    [0, 3, 8], [1, 3, 8], [2, 3, 8], [3, 3, 8], [4, 3, 8], [5, 3, 8], [6, 3, 8], [7, 3, 8], [8, 3, 8],
    [0, 4, 8], [1, 4, 8], [2, 4, 8], [3, 4, 8], [4, 4, 8], [5, 4, 8], [6, 4, 8], [7, 4, 8], [8, 4, 8],
    [0, 5, 8], [1, 5, 8], [2, 5, 8], [3, 5, 8], [4, 5, 8], [5, 5, 8], [6, 5, 8], [7, 5, 8], [8, 5, 8],
    [0, 6, 8], [1, 6, 8], [2, 6, 8], [3, 6, 8], [4, 6, 8], [5, 6, 8], [6, 6, 8], [7, 6, 8], [8, 6, 8],
    [0, 7, 8], [1, 7, 8], [2, 7, 8], [3, 7, 8], [4, 7, 8], [5, 7, 8], [6, 7, 8], [7, 7, 8], [8, 7, 8],
    [0, 8, 8], [1, 8, 8], [2, 8, 8], [3, 8, 8], [4, 8, 8], [5, 8, 8], [6, 8, 8], [7, 8, 8], [8, 8, 8],

    [0, 0, 9], [1, 0, 9], [2, 0, 9], [3, 0, 9], [4, 0, 9], [5, 0, 9], [6, 0, 9], [7, 0, 9], [8, 0, 9],
    [0, 1, 9], [1, 1, 9], [2, 1, 9], [3, 1, 9], [4, 1, 9], [5, 1, 9], [6, 1, 9], [7, 1, 9], [8, 1, 9],
    [0, 2, 9], [1, 2, 9], [2, 2, 9], [3, 2, 9], [4, 2, 9], [5, 2, 9], [6, 2, 9], [7, 2, 9], [8, 2, 9],
    [0, 3, 9], [1, 3, 9], [2, 3, 9], [3, 3, 9], [4, 3, 9], [5, 3, 9], [6, 3, 9], [7, 3, 9], [8, 3, 9],
    [0, 4, 9], [1, 4, 9], [2, 4, 9], [3, 4, 9], [4, 4, 9], [5, 4, 9], [6, 4, 9], [7, 4, 9], [8, 4, 9],
    [0, 5, 9], [1, 5, 9], [2, 5, 9], [3, 5, 9], [4, 5, 9], [5, 5, 9], [6, 5, 9], [7, 5, 9], [8, 5, 9],
    [0, 6, 9], [1, 6, 9], [2, 6, 9], [3, 6, 9], [4, 6, 9], [5, 6, 9], [6, 6, 9], [7, 6, 9], [8, 6, 9],
    [0, 7, 9], [1, 7, 9], [2, 7, 9], [3, 7, 9], [4, 7, 9], [5, 7, 9], [6, 7, 9], [7, 7, 9], [8, 7, 9],
    [0, 8, 9], [1, 8, 9], [2, 8, 9], [3, 8, 9], [4, 8, 9], [5, 8, 9], [6, 8, 9], [7, 8, 9], [8, 8, 9],
    [0, 0, 10], [1, 0, 10], [2, 0, 10], [3, 0, 10], [4, 0, 10], [5, 0, 10], [6, 0, 10], [7, 0, 10], [8, 0, 10],
    [0, 1, 10], [1, 1, 10], [2, 1, 10], [3, 1, 10], [4, 1, 10], [5, 1, 10], [6, 1, 10], [7, 1, 10], [8, 1, 10],
    [0, 2, 10], [1, 2, 10], [2, 2, 10], [3, 2, 10], [4, 2, 10], [5, 2, 10], [6, 2, 10], [7, 2, 10], [8, 2, 10],
    [0, 3, 10], [1, 3, 10], [2, 3, 10], [3, 3, 10], [4, 3, 10], [5, 3, 10], [6, 3, 10], [7, 3, 10], [8, 3, 10],
    [0, 4, 10], [1, 4, 10], [2, 4, 10], [3, 4, 10], [4, 4, 10], [5, 4, 10], [6, 4, 10], [7, 4, 10], [8, 4, 10],
    [0, 5, 10], [1, 5, 10], [2, 5, 10], [3, 5, 10], [4, 5, 10], [5, 5, 10], [6, 5, 10], [7, 5, 10], [8, 5, 10],
    [0, 6, 10], [1, 6, 10], [2, 6, 10], [3, 6, 10], [4, 6, 10], [5, 6, 10], [6, 6, 10], [7, 6, 10], [8, 6, 10],
    [0, 7, 10], [1, 7, 10], [2, 7, 10], [3, 7, 10], [4, 7, 10], [5, 7, 10], [6, 7, 10], [7, 7, 10], [8, 7, 10],
    [0, 8, 10], [1, 8, 10], [2, 8, 10], [3, 8, 10], [4, 8, 10], [5, 8, 10], [6, 8, 10], [7, 8, 10], [8, 8, 10],
    [0, 0, 11], [1, 0, 11], [2, 0, 11], [3, 0, 11], [4, 0, 11], [5, 0, 11], [6, 0, 11], [7, 0, 11], [8, 0, 11],
    [0, 1, 11], [1, 1, 11], [2, 1, 11], [3, 1, 11], [4, 1, 11], [5, 1, 11], [6, 1, 11], [7, 1, 11], [8, 1, 11],
    [0, 2, 11], [1, 2, 11], [2, 2, 11], [3, 2, 11], [4, 2, 11], [5, 2, 11], [6, 2, 11], [7, 2, 11], [8, 2, 11],
    [0, 3, 11], [1, 3, 11], [2, 3, 11], [3, 3, 11], [4, 3, 11], [5, 3, 11], [6, 3, 11], [7, 3, 11], [8, 3, 11],
    [0, 4, 11], [1, 4, 11], [2, 4, 11], [3, 4, 11], [4, 4, 11], [5, 4, 11], [6, 4, 11], [7, 4, 11], [8, 4, 11],
    [0, 5, 11], [1, 5, 11], [2, 5, 11], [3, 5, 11], [4, 5, 11], [5, 5, 11], [6, 5, 11], [7, 5, 11], [8, 5, 11],
    [0, 6, 11], [1, 6, 11], [2, 6, 11], [3, 6, 11], [4, 6, 11], [5, 6, 11], [6, 6, 11], [7, 6, 11], [8, 6, 11],
    [0, 7, 11], [1, 7, 11], [2, 7, 11], [3, 7, 11], [4, 7, 11], [5, 7, 11], [6, 7, 11], [7, 7, 11], [8, 7, 11],
    [0, 8, 11], [1, 8, 11], [2, 8, 11], [3, 8, 11], [4, 8, 11], [5, 8, 11], [6, 8, 11], [7, 8, 11], [8, 8, 11],
    [0, 0, 12], [1, 0, 12], [2, 0, 12], [3, 0, 12], [4, 0, 12], [5, 0, 12], [6, 0, 12], [7, 0, 12], [8, 0, 12],
    [0, 1, 12], [1, 1, 12], [2, 1, 12], [3, 1, 12], [4, 1, 12], [5, 1, 12], [6, 1, 12], [7, 1, 12], [8, 1, 12],
    [0, 2, 12], [1, 2, 12], [2, 2, 12], [3, 2, 12], [4, 2, 12], [5, 2, 12], [6, 2, 12], [7, 2, 12], [8, 2, 12],
    [0, 3, 12], [1, 3, 12], [2, 3, 12], [3, 3, 12], [4, 3, 12], [5, 3, 12], [6, 3, 12], [7, 3, 12], [8, 3, 12],
    [0, 4, 12], [1, 4, 12], [2, 4, 12], [3, 4, 12], [4, 4, 12], [5, 4, 12], [6, 4, 12], [7, 4, 12], [8, 4, 12],
    [0, 5, 12], [1, 5, 12], [2, 5, 12], [3, 5, 12], [4, 5, 12], [5, 5, 12], [6, 5, 12]
];
